Page MenuHomePhabricator

Switchover s1 from db1163 to db1118
Closed, ResolvedPublic

Description

When: 3rd November 2021

Checklist:

  • Create a task to communicate the chosen date and send an announcement to the community: T293965
  • Create a calendar entry for the maintenance, invite sre-data-persistence@
  • Add to deployments calendar. E.g.:
{{Deployment calendar event card
    |when=2021-11-2 22:00 SF
    |length=0.5
    |window=Database primary switchover for s1
    |who={{ircnick|kormat|Stevie Beth Mhaol}}, {{ircnick|marostegui|Manuel 'Early Bird' Arostegui}}
    |what=https://phabricator.wikimedia.org/T293964
}}

NEW primary: db1118
OLD primary: db1163

  • Check configuration differences between new and old primary:
sudo pt-config-diff --defaults-file /root/.my.cnf h=db1163.eqiad.wmnet h=db1118.eqiad.wmnet

Failover prep:

  • Silence alerts on all hosts:
sudo cookbook sre.hosts.downtime --hours 1 -r "Primary switchover s1 T293964" 'A:db-section-s1'
  • Set NEW primary with weight 0
sudo dbctl instance db1118 set-weight 0
sudo dbctl config commit -m "Set db1118 with weight 0 T293964"
  • Topology changes, move all replicas under NEW primary
sudo db-switchover --timeout=15 --only-slave-move db1163 db1118
  • Disable puppet on both nodes
sudo cumin 'db1163* or db1118*' 'disable-puppet "primary switchover T293964"'

Failover:

  • Log the failover:
!log Starting s1 eqiad failover from db1163 to db1118 - T293964
  • Set section read-only:
sudo dbctl --scope eqiad section s1 ro "Maintenance until 06:15 UTC - T293964"
sudo dbctl config commit -m "Set s1 eqiad as read-only for maintenance - T293964"
  • Check s1 is indeed read-only
  • Switch primaries:
sudo db-switchover --skip-slave-move db1163 db1118
echo "===== db1163 (OLD)"; sudo mysql.py -h db1163 -e 'show slave status\G'
echo "===== db1118 (NEW)"; sudo mysql.py -h db1118 -e 'show slave status\G'
  • Promote NEW primary in dbctl, and remove read-only
sudo dbctl --scope eqiad section s1 set-master db1118
sudo dbctl --scope eqiad section s1 rw
sudo dbctl config commit -m "Promote db1118 to s1 primary and set section read-write T293964"
  • Restart puppet on both hosts:
sudo cumin 'db1163* or db1118*' 'run-puppet-agent -e "primary switchover T293964"'

Clean up tasks:

  • Clean up heartbeat table(s).
  • change events for query killer:
events_coredb_master.sql on the new primary db1118
events_coredb_slave.sql on the new slave db1163
sudo dbctl instance db1163 set-candidate-master --section s1 true
sudo dbctl instance db1118 set-candidate-master --section s1 false
  • Check tendril was updated
  • Check zarcillo was updated
  • Depool OLD primary, as it's running 10.1, replicating from a 10.4 primary
sudo dbctl instance db1163 depool
sudo dbctl config commit -m "Depool db1163 until it's reimaged to buster T293964"
  • Apply outstanding schema changes to db1163 (if any) NONE
  • Update/resolve this ticket.

Event Timeline

Marostegui updated the task description. (Show Details)
Marostegui moved this task from Triage to Ready on the DBA board.

Change 736114 had a related patch set uploaded (by Marostegui; author: Marostegui):

[operations/puppet@production] mariadb: Promote db1118 to s1 master

https://gerrit.wikimedia.org/r/736114

Change 736115 had a related patch set uploaded (by Marostegui; author: Marostegui):

[operations/dns@master] wmnet: Update s1-master CNAME

https://gerrit.wikimedia.org/r/736115

Mentioned in SAL (#wikimedia-operations) [2021-11-02T10:03:49Z] <marostegui@cumin1001> dbctl commit (dc=all): 'Set db1118 with weight 0 T293964', diff saved to https://phabricator.wikimedia.org/P17652 and previous config saved to /var/cache/conftool/dbconfig/20211102-100348-root.json

Mentioned in SAL (#wikimedia-operations) [2021-11-03T05:01:18Z] <marostegui@cumin1001> START - Cookbook sre.hosts.downtime for 1:00:00 on 32 hosts with reason: Primary switchover s1 T293964

Mentioned in SAL (#wikimedia-operations) [2021-11-03T05:01:42Z] <marostegui@cumin1001> END (PASS) - Cookbook sre.hosts.downtime (exit_code=0) for 1:00:00 on 32 hosts with reason: Primary switchover s1 T293964

Change 736114 merged by Marostegui:

[operations/puppet@production] mariadb: Promote db1118 to s1 master

https://gerrit.wikimedia.org/r/736114

Mentioned in SAL (#wikimedia-operations) [2021-11-03T06:00:58Z] <marostegui> Starting s1 eqiad failover from db1163 to db1118 - T293964

Mentioned in SAL (#wikimedia-operations) [2021-11-03T06:01:14Z] <marostegui@cumin1001> dbctl commit (dc=all): 'Set s1 eqiad as read-only for maintenance - T293964', diff saved to https://phabricator.wikimedia.org/P17657 and previous config saved to /var/cache/conftool/dbconfig/20211103-060114-root.json

Mentioned in SAL (#wikimedia-operations) [2021-11-03T06:02:02Z] <marostegui@cumin1001> dbctl commit (dc=all): 'Promote db1118 to s1 primary and set section read-write T293964', diff saved to https://phabricator.wikimedia.org/P17658 and previous config saved to /var/cache/conftool/dbconfig/20211103-060201-root.json

Change 736115 merged by Marostegui:

[operations/dns@master] wmnet: Update s1-master CNAME

https://gerrit.wikimedia.org/r/736115

Mentioned in SAL (#wikimedia-operations) [2021-11-03T06:06:44Z] <marostegui@cumin1001> dbctl commit (dc=all): 'Depool db1163 until it's reimaged to buster T293964', diff saved to https://phabricator.wikimedia.org/P17659 and previous config saved to /var/cache/conftool/dbconfig/20211103-060644-root.json

This was done.
RO started: 06:01:14
RO finished: 06:02:02
Total RO time: 48 seconds

Resolving this, db1163's reimage will be handled at T290865